# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::AlertsManagement::Mgmt::V2019_05_05_preview
  module Models
    #
    # Conditions in alert instance to be matched for a given action rule.
    # Default value is all. Multiple values could be provided with comma
    # separation.
    #
    class Conditions

      include MsRestAzure

      # @return [Condition] filter alerts by severity
      attr_accessor :severity

      # @return [Condition] filter alerts by monitor service
      attr_accessor :monitor_service

      # @return [Condition] filter alerts by monitor condition
      attr_accessor :monitor_condition

      # @return [Condition] filter alerts by target resource type
      attr_accessor :target_resource_type

      # @return [Condition] filter alerts by alert rule id
      attr_accessor :alert_rule_id

      # @return [Condition] filter alerts by alert rule description
      attr_accessor :description

      # @return [Condition] filter alerts by alert context (payload)
      attr_accessor :alert_context


      #
      # Mapper for Conditions class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Conditions',
          type: {
            name: 'Composite',
            class_name: 'Conditions',
            model_properties: {
              severity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'severity',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              },
              monitor_service: {
                client_side_validation: true,
                required: false,
                serialized_name: 'monitorService',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              },
              monitor_condition: {
                client_side_validation: true,
                required: false,
                serialized_name: 'monitorCondition',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              },
              target_resource_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'targetResourceType',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              },
              alert_rule_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'alertRuleId',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              },
              alert_context: {
                client_side_validation: true,
                required: false,
                serialized_name: 'alertContext',
                type: {
                  name: 'Composite',
                  class_name: 'Condition'
                }
              }
            }
          }
        }
      end
    end
  end
end
